Index: trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/3.3/Ontology.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/3.3/Ontology.cs	(revision 2045)
+++ trunk/sources/HeuristicLab.CEDMA.DB.Interfaces/3.3/Ontology.cs	(revision 2047)
@@ -63,5 +63,5 @@
 
     #region meta-data predicates
-    public static Entity PredicateName {
+    public static Entity Name {
       get { return new Entity(CedmaNameSpace + "Name"); }
     }
@@ -69,5 +69,5 @@
     /// Each entity can have a serialized XML representation that can be loaded in HL.
     /// </summary>
-    public static Entity PredicateSerializedData {
+    public static Entity SerializedData {
       get { return new Entity(CedmaNameSpace + "SerializedData"); }
     }
@@ -76,5 +76,5 @@
     /// A data set can have multiple models.
     /// </summary>
-    public static Entity PredicateHasModel {
+    public static Entity HasModel {
       get { return new Entity(CedmaNameSpace + "Model"); }
     }
@@ -83,11 +83,18 @@
     /// An algorithm can generate multiple models, each model is generated by exactly one algorithm.
     /// </summary>
-    public static Entity PredicateGeneratedBy {
+    public static Entity GeneratedBy {
       get { return new Entity(CedmaNameSpace + "GeneratedBy"); }
     }
+    /// <summary>
+    /// Link from model to input variable impact
+    /// Each model can have multiple input variables and each of the input variables can have a different impact on the model.
+    /// </summary>
+    public static Entity HasInputVariable {
+      get { return new Entity(CedmaNameSpace + "InputVariable"); }
+    }
     #endregion
 
     #region types and type relations
-    public static Entity PredicateInstanceOf {
+    public static Entity InstanceOf {
       get { return new Entity(CedmaNameSpace + "InstanceOf"); }
     }
@@ -102,15 +109,12 @@
     }
     public static Entity TypeVariableImpact {
-      get { return new Entity(CedmaNameSpace + "VariableQualityImpact"); }
-    }
-    #endregion
-
-    #region default attributes
+      get { return new Entity(CedmaNameSpace + "VariableImpact"); }
+    }
+    #endregion
+
+    #region attributes for models
     public static Entity TargetVariable {
       get { return new Entity(CedmaNameSpace + "TargetVariable"); }
     }
-    public static Entity AlgorithmName {
-      get { return new Entity(CedmaNameSpace + "AlgorithmName"); }
-    }
     public static Entity TrainingMeanSquaredError {
       get { return new Entity(CedmaNameSpace + "TrainingMeanSquaredError"); }
@@ -184,4 +188,12 @@
     public static Entity EvaluatedSolutions {
       get { return new Entity(CedmaNameSpace + "EvaluatedSolutions"); }
+    }
+    #endregion
+    #region attributes for input variables
+    public static Entity EvaluationImpact {
+      get { return new Entity(CedmaNameSpace + "EvaluationImpact"); }
+    }
+    public static Entity QualityImpact {
+      get { return new Entity(CedmaNameSpace + "QualityImpact"); }
     }
     #endregion
@@ -190,48 +202,51 @@
       get {
         return new List<Statement> {
-          new Statement(TargetVariable, PredicateInstanceOf, TypeCategoricalAttribute),
-          new Statement(AlgorithmName, PredicateInstanceOf, TypeCategoricalAttribute),
-          new Statement(TrainingMeanSquaredError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TrainingMeanSquaredError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(ValidationMeanSquaredError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(ValidationMeanSquaredError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TestMeanSquaredError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TestMeanSquaredError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TrainingMeanAbsolutePercentageError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TrainingMeanAbsolutePercentageError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(ValidationMeanAbsolutePercentageError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(ValidationMeanAbsolutePercentageError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TestMeanAbsolutePercentageError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TestMeanAbsolutePercentageError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TrainingMeanAbsolutePercentageOfRangeError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TrainingMeanAbsolutePercentageOfRangeError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(ValidationMeanAbsolutePercentageOfRangeError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(ValidationMeanAbsolutePercentageOfRangeError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TestMeanAbsolutePercentageOfRangeError, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TestMeanAbsolutePercentageOfRangeError, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TrainingCoefficientOfDetermination, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TrainingCoefficientOfDetermination, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(ValidationCoefficientOfDetermination, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(ValidationCoefficientOfDetermination, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TestCoefficientOfDetermination, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TestCoefficientOfDetermination, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TrainingAccuracy, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TrainingAccuracy, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(ValidationAccuracy, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(ValidationAccuracy, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TestAccuracy, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TestAccuracy, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TrainingTheilsInequalityCoefficient, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TrainingTheilsInequalityCoefficient, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(ValidationTheilsInequalityCoefficient, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(ValidationTheilsInequalityCoefficient, PredicateInstanceOf, TypeQualityAttribute),
-          new Statement(TestTheilsInequalityCoefficient, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TestTheilsInequalityCoefficient, PredicateInstanceOf, TypeQualityAttribute),
-
-          new Statement(TreeSize, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TreeSize, PredicateInstanceOf, TypeComplexityAttribute),
-          new Statement(TreeHeight, PredicateInstanceOf, TypeOrdinalAttribute),
-          new Statement(TreeHeight, PredicateInstanceOf, TypeComplexityAttribute),
-          new Statement(EvaluatedSolutions, PredicateInstanceOf, TypeOrdinalAttribute)
+          new Statement(TargetVariable, InstanceOf, TypeCategoricalAttribute),
+          new Statement(TrainingMeanSquaredError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TrainingMeanSquaredError, InstanceOf, TypeQualityAttribute),
+          new Statement(ValidationMeanSquaredError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(ValidationMeanSquaredError, InstanceOf, TypeQualityAttribute),
+          new Statement(TestMeanSquaredError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TestMeanSquaredError, InstanceOf, TypeQualityAttribute),
+          new Statement(TrainingMeanAbsolutePercentageError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TrainingMeanAbsolutePercentageError, InstanceOf, TypeQualityAttribute),
+          new Statement(ValidationMeanAbsolutePercentageError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(ValidationMeanAbsolutePercentageError, InstanceOf, TypeQualityAttribute),
+          new Statement(TestMeanAbsolutePercentageError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TestMeanAbsolutePercentageError, InstanceOf, TypeQualityAttribute),
+          new Statement(TrainingMeanAbsolutePercentageOfRangeError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TrainingMeanAbsolutePercentageOfRangeError, InstanceOf, TypeQualityAttribute),
+          new Statement(ValidationMeanAbsolutePercentageOfRangeError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(ValidationMeanAbsolutePercentageOfRangeError, InstanceOf, TypeQualityAttribute),
+          new Statement(TestMeanAbsolutePercentageOfRangeError, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TestMeanAbsolutePercentageOfRangeError, InstanceOf, TypeQualityAttribute),
+          new Statement(TrainingCoefficientOfDetermination, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TrainingCoefficientOfDetermination, InstanceOf, TypeQualityAttribute),
+          new Statement(ValidationCoefficientOfDetermination, InstanceOf, TypeOrdinalAttribute),
+          new Statement(ValidationCoefficientOfDetermination, InstanceOf, TypeQualityAttribute),
+          new Statement(TestCoefficientOfDetermination, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TestCoefficientOfDetermination, InstanceOf, TypeQualityAttribute),
+          new Statement(TrainingAccuracy, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TrainingAccuracy, InstanceOf, TypeQualityAttribute),
+          new Statement(ValidationAccuracy, InstanceOf, TypeOrdinalAttribute),
+          new Statement(ValidationAccuracy, InstanceOf, TypeQualityAttribute),
+          new Statement(TestAccuracy, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TestAccuracy, InstanceOf, TypeQualityAttribute),
+          new Statement(TrainingTheilsInequalityCoefficient, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TrainingTheilsInequalityCoefficient, InstanceOf, TypeQualityAttribute),
+          new Statement(ValidationTheilsInequalityCoefficient, InstanceOf, TypeOrdinalAttribute),
+          new Statement(ValidationTheilsInequalityCoefficient, InstanceOf, TypeQualityAttribute),
+          new Statement(TestTheilsInequalityCoefficient, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TestTheilsInequalityCoefficient, InstanceOf, TypeQualityAttribute),
+
+          new Statement(TreeSize, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TreeSize, InstanceOf, TypeComplexityAttribute),
+          new Statement(TreeHeight, InstanceOf, TypeOrdinalAttribute),
+          new Statement(TreeHeight, InstanceOf, TypeComplexityAttribute),
+          new Statement(EvaluatedSolutions, InstanceOf, TypeOrdinalAttribute),
+
+          new Statement(Name, InstanceOf, TypeCategoricalAttribute),
+          new Statement(QualityImpact, InstanceOf, TypeOrdinalAttribute),
+          new Statement(EvaluationImpact, InstanceOf, TypeOrdinalAttribute)
         };
       }